#!/usr/bin/env bash

PS_ROOT="/home/pinsound/"
PS_AUDIO="${PS_ROOT}audio/"
PS_USB_MNT="/tmp/pinsound/"
PS_DEV_USB="/dev/sda1"

PS_PLAYPINSOUND="${PS_ROOT}bin/playPinSound"

PS_ALSA_VOLUME_BASH="35%"
PS_ALSA_VOLUME_PLAYPINSOUND="80%"
PS_ALSA_VOLUME_DAC="90%"

function endUpdate()
{
	mount -o remount,ro /

	sendCommandPsoc "LEDWHITE"

	freeAudio
	aplay ${PS_AUDIO}The_system_is_now_updated.wav
	for run in {1..3}
	do
		aplay ${PS_AUDIO}Please__restart_the_pinball_machine_now.wav
	done
	freeAudioEnd
	exit 0
}

function sendCommandPsoc()
{
	stty -F /dev/ttyS1 speed 115200
	echo -ne "${1}\n" > /dev/ttyS1
}

function checkUpdate()
{
	if  [ -f ${PS_ROOT}factory/pinsound-init.psrom2 ]
	then
		sendCommandPsoc "READY"
		sendCommandPsoc "LEDRED"

		mount -o remount,rw /
		mv ${PS_ROOT}factory/pinsound-init.* ${PS_USB_MNT}pinsound-update-0000.psrom2
        sync
        mount -o remount,ro /
	fi

	if  [ -f ${PS_USB_MNT}pinsound-init.psrom2 ]
	then
	        cp ${PS_USB_MNT}pinsound-init.* ${PS_USB_MNT}pinsound-update-0000.psrom2
	        sync
	fi

	if ls ${PS_USB_MNT}pinsound-update*.bin &> /dev/null
	then
		UPDATE_FILENAME_BIN=`ls ${PS_USB_MNT}pinsound-update*.bin | tail -1`
		echo "Found pinsound-update BIN -> conver to PSROM"
		mv "${UPDATE_FILENAME_BIN}" "${UPDATE_FILENAME_BIN%.bin}.psrom"
	fi

	if ls ${PS_USB_MNT}pinsound-update*.psrom2 &> /dev/null
	then
		UPDATE_FILENAME=`ls ${PS_USB_MNT}pinsound-update*.psrom2 | tail -1`

		sendCommandPsoc "RESET"
		sleep 1
		freeAudio
		aplay ${PS_AUDIO}The_system_is_currently_updating._Please_wait.wav
		mpg123 -q --loop 99 ${PS_ROOT}audio/music_updating.mp3 &

		# to be sure, remount root filesystem in RW
		mount -o remount,rw /

		if [ ! -d ${PS_USB_MNT}tmp ]
		then
			mkdir ${PS_USB_MNT}tmp
		fi
		cp "${UPDATE_FILENAME}" ${PS_USB_MNT}tmp/
		UPDATE_FILENAME_BASENAME=$(basename "$UPDATE_FILENAME")
		mv "${PS_USB_MNT}tmp/${UPDATE_FILENAME_BASENAME}" ${PS_USB_MNT}tmp/update.tar.gz
		
		# remove old previous master configs
		rm -f ${PS_ROOT}pinball/*

		# remove previous res file
		rm ${PS_ROOT}bin/psoc.pinsound
		
		tar zxf ${PS_USB_MNT}tmp/update.tar.gz -C /
		chmod +x ${PS_ROOT}startPinSound.sh
		rm ${PS_USB_MNT}tmp/update.tar.gz
		rm "${UPDATE_FILENAME}"
		sync

		#if  [ -f ${PS_ROOT}/pinsound.service.new ]
		#then
		#	mount -o remount,rw /
		#	mv ${PS_ROOT}/pinsound.service.new ${PS_ROOT}/pinsound.service
		#	systemctl disable pinsound.service
		#	systemctl enable /home/pinsound/pinsound.service
        #	sync
        #	mount -o remount,ro /
		#fi

		# check update PSOC
		checkUpdatePSoC
		result_checkUpdatePSoC=$?
		if [[ $result_checkUpdatePSoC -ne 0 ]] 
		then
			freeAudio
			aplay ${PS_AUDIO}Technical_problem_please_contact_the_support_team.wav
			freeAudioEnd
			exit 1
		else
			endUpdate
			exit 0
		fi

	fi

	# check update PSOC
	if compgen -G "${PS_ROOT}/psocML/firmware*.bin" > /dev/null
	then
		checkUpdatePSoC
		result_checkUpdatePSoC=$?
		if [[ $result_checkUpdatePSoC -ne 0 ]] 
		then
			freeAudio
			aplay ${PS_AUDIO}Technical_problem_please_contact_the_support_team.wav
			freeAudioEnd
			exit 1
		else
			endUpdate
			exit 0
		fi
	fi

	return 0
}

function checkUpdatePSoC()
{

	#if ls ${PS_ROOT}/psocML/firmware*.bin &> /dev/null
	if compgen -G "${PS_ROOT}/psocML/firmware*.bin" > /dev/null
	then

		sendCommandPsoc "RESET"
		sleep 1
		freeAudio
		aplay ${PS_AUDIO}The_system_is_currently_updating._Please_wait.wav
		
		# no background music, no bg process allowed
		#mpg123 -q --loop 99 ${PS_ROOT}audio/music_updating.mp3 &

		find ${PS_ROOT}/psocML/ -type f -regex '.*firmware-.*[M|L]\.bin' | while read firmware_file; do
			mount -o remount,rw /
			chmod +x $firmware_file
			mount -o remount,ro /

			for run in {1..10}
			do
				$firmware_file
				funcResult=$?
				if [[ $funcResult -eq 0 ]] 
				then
					mount -o remount,rw /
					rm ${PS_ROOT}/psocML/firmware*.bin
					removeMixTreeCache
					sync
					mount -o remount,ro /

					sleep 1
					sendCommandPsoc "RESET"
					sleep 1

					return 0
				fi
			done
		done
		return $?
	fi
	return 0

	#if ls ${PS_ROOT}/psoc/firmware*.bin &> /dev/null
	#then
	#	
	#	FIRMWARE_FILENAME=`ls ${PS_ROOT}/psoc/firmware*.bin | tail -1`
	#	FIRMWARE_VERSION=${FIRMWARE_FILENAME#*-}; # FIRMWARE_VERSION = "-X.bin"
	#	FIRMWARE_VERSION=${FIRMWARE_VERSION%-*}; 	# FIRMWARE_VERSION = "X"
	#
	#	PSOC_TO_UPDATE=1
	#	
	#	if [[ "$PSOC_TO_UPDATE" == 1 ]]
	#	then
	#		
	#		for run in {1..3}
	#		do
	#			chmod +x ${FIRMWARE_FILENAME}
	#			${FIRMWARE_FILENAME}
	#			funcResult=$?
	#			if [[ $funcResult -eq 0 ]] 
	#			then
	#				rm ${PS_ROOT}/psoc/firmware*.bin
	##				removeMixTreeCache
	##				sync
	#				return 0
	#			fi
	#		done
	#
	#		if [[ $funcResult -eq 1 ]] 
	#		then
	#			freeAudio
	#			aplay ${PS_AUDIO}Technical_problem_please_contact_the_support_team.wav
	#			freeAudioEnd
	#			exit 1
	#		fi
	#	fi
	#	rm ${PS_ROOT}/psoc/firmware*.bin
	#	removeMixTreeCache
	#	sync
	#fi
	#return 1

}

function checkInstallPrerequisites()
{
	# check if binary playPinSound is available
	if [ ! -f ${PS_PLAYPINSOUND} ]
	then
		return 0
	fi

	# check if "audio" directory is created on the USB flash drive
	if [ ! -d ${PS_USB_MNT}audio ]
	then
		mkdir ${PS_USB_MNT}audio
	fi
	
	# check if "tmp" directory is created on the USB flash drive
	if [ ! -d ${PS_USB_MNT}tmp ]
	then
		mkdir ${PS_USB_MNT}tmp
	fi

	# are extra tools as "sox" installed
	which sox
	result_which=$?
	if [[ $result_which != 0 ]] 
	then
		if [ -f ${PS_ROOT}pkg/libgsm1_1.0.13-4_armhf.deb ] && [ -f ${PS_ROOT}pkg/libopencore-amrwb0_0.1.3-2.1_armhf.deb ] && [ -f ${PS_ROOT}pkg/libsox-fmt-alsa_14.4.1-5_armhf.deb ] && [ -f ${PS_ROOT}pkg/libwavpack1_4.75.2-2_armhf.deb ] && [ -f ${PS_ROOT}pkg/libsox2_14.4.1-5_armhf.deb ] && [ -f ${PS_ROOT}pkg/libsox-fmt-base_14.4.1-5_armhf.deb ] && [ -f ${PS_ROOT}pkg/sox_14.4.1-5_armhf.deb ] 
		then
			mount -o remount,rw /
			dpkg -i ${PS_ROOT}pkg/libgsm1_1.0.13-4_armhf.deb ${PS_ROOT}pkg/libopencore-amrwb0_0.1.3-2.1_armhf.deb ${PS_ROOT}pkg/libsox-fmt-alsa_14.4.1-5_armhf.deb ${PS_ROOT}pkg/libwavpack1_4.75.2-2_armhf.deb ${PS_ROOT}pkg/libopencore-amrnb0_0.1.3-2.1_armhf.deb ${PS_ROOT}pkg/libsox2_14.4.1-5_armhf.deb  ${PS_ROOT}pkg/libsox-fmt-base_14.4.1-5_armhf.deb ${PS_ROOT}pkg/sox_14.4.1-5_armhf.deb
			result_dpkg=$?

			# back to our own openal library version (symlink automatically updated by dpkg)
			rm /usr/lib/arm-linux-gnueabihf/libopenal.so.1
			ln -s /usr/lib/arm-linux-gnueabihf/libopenal.so.1.17.2 /usr/lib/arm-linux-gnueabihf/libopenal.so.1

			mount -o remount,ro /
			
			if [[ result_dpkg == 1 ]] 
			then
				freeAudio
				aplay ${PS_ROOT}audio/Due_to_major_problems__please_update_the_PinSound_system.wav
				echo "missing pkg archives"
				return 1;
			fi
		fi
	fi

	return 1
}

function loadDefault()
{
	# to be sure, remount root filesystem in RW
	mount -o remount,rw /

	if [ ! -f ${PS_ROOT}default/default.tar.gz ]
	then
		tar zxf ${PS_ROOT}default/default.tar.gz -C /
		sync
		checkUpdatePSoC
		endUpdate
	fi
	return 0
}

function checkDiskUsb()
{
	freeAudio
	aplay ${PS_ROOT}audio/Checking_USB_flash_drive_for_errors_please_wait.wav
	mpg123 -q --loop 99 ${PS_ROOT}audio/music_updating.mp3 &
	
	checkInstallPrerequisites

	# unmount USB
	umount ${PS_DEV_USB}

	# launch dosfsck
	dosfsck -a -w ${PS_DEV_USB}
	result_fsck=$?

	# remount USB
	mountpoint -q ${PS_USB_MNT} || mount -o rw,errors=continue ${PS_DEV_USB} ${PS_USB_MNT}

	# 1 = errors found
	# 0 = no errors
	return $result_fsck
}

function processTmp()
{
	# clean hidden files (thank you OSX with your fucking hidden files...)
	find "${PS_USB_MNT}tmp" -name '.*' ! -name '.' ! -name '..' -delete

	one_sound_pack_processed=0

	count_to_process=`find ${PS_USB_MNT}tmp -maxdepth 1 -type d ! -path ${PS_USB_MNT}tmp 2>/dev/null | wc -l`
	if [[ $count_to_process -gt 0 ]]
	then
		echo "sound pack to process 1"
		one_sound_pack_processed=1
	fi

	find ${PS_USB_MNT}tmp -maxdepth 1 -type d ! -path ${PS_USB_MNT}tmp | while read mix_dir; do
		
		removeMixTreeCache

		# has_ogg=$(hasOggFiles "$mix_dir")
		# if [[ $has_ogg -eq 0 ]]
		# then	
		# 	echo "Mix $mix_dir contains no OGG files"

			# WAV or OGG files, we can directly move this mix to audio directory
			echo "Mix $mix_dir will be moved to audio folder"
			
			random_music=$[($RANDOM % ($[3 - 1] + 1)) + 1]
			freeAudio
			mpg123 -q --loop 99 ${PS_ROOT}audio/music_conversion_${random_music}.mp3 &

			rsync -a "$mix_dir" ${PS_USB_MNT}audio/
			rm -rf "$mix_dir"
			sync
			
		# fi

		# get count of OGG files to convert
		# total_ogg=$(find "$mix_dir" -type f -iname "*.ogg" | wc -l)
		# echo "total OGG : $total_ogg"

		# launch ogg to wav conversion
		# random_music=$[($RANDOM % ($[3 - 1] + 1)) + 1]
		# freeAudio
		# mpg123 -q --loop 99 ${PS_ROOT}audio/music_conversion_${random_music}.mp3 &
		# echo "Ogg to Wav conversion : $mix_dir"
		# count=0
		# current_percent=-1
		# find "$mix_dir" -type f -iname "*.ogg" | sort -R | while read ogg_file; do
			
		# 	#wav_file="$(dirname $ogg_file)/$(basename $ogg_file .ogg).wav"
		# 	#echo "$ogg_tmp => $wav_file"
		# 	oggdec -Q "$ogg_file"
		# 	result_oggdec=$?
		# 	if [[ $result_oggdec == 0 ]] 
		# 	then
		# 		rm "$ogg_file"
		# 		sync
		# 	else
		# 		sync

		# 		echo "Error during wav conversion"
		# 		for run in {1..2}
		# 		do
		# 			freeAudio
		# 			aplay ${PS_ROOT}audio/Error_encountered_during_audio_conversion.wav
		# 			freeAudioEnd
		# 		done

		# 		# maybe it's a disk space problem?
		# 		usb_free_space=$(getFreeSpace ${PS_USB_MNT})
		# 		if [[ $usb_free_space -lt 50000000 ]]; then
		# 			echo "The USB flash drive does not have enough free space."
		# 			for run in {1..3}
		# 			do
		# 				aplay ${PS_ROOT}audio/The_USB_flash_drive_does_not_have_enough_free_space.wav
		# 			done
		# 		fi

		# 		# launch dosfsck to check the USB flash drive
		# 		checkDiskUsb

		# 		# user must fix the problem, we exit
		# 		return 1;
		# 	fi
			
		# 	count=$((count+1))
		# 	#echo -ne "Progression : $count / $total_ogg \r"
		# 	percent_progress=$(($count * 100 / $total_ogg))
		# 	if [[ $percent_progress != $current_percent ]]; then
		# 		if [[ $(expr $current_percent % 10) == 0 ]]; then
		# 			if [ -f ${PS_ROOT}audio/${current_percent}_percent_completed.wav ]; then
		# 				freeAudio
		# 				aplay ${PS_ROOT}audio/${current_percent}_percent_completed.wav
		# 				skip_frames=$[($RANDOM % ($[4000 - 500] + 1)) + 500]
		# 				mpg123 -q --loop 99 --skip $skip_frames ${PS_ROOT}audio/music_conversion_${random_music}.mp3 &
		# 			fi
		# 		fi
		# 		echo "Progression : $count / $total_ogg | Percent : $percent_progress"
		# 	else
		# 		echo "."
		# 	fi
		# 	current_percent=$percent_progress
		# 	#sleep 0.2

		# done
		
		# has_ogg=$(hasOggFiles "$mix_dir")
		# if [[ $has_ogg -eq 0 ]]
		# then	
		# 	# no more OGG files, we can move this mix to audio directory
		# 	rsync -a "$mix_dir" ${PS_USB_MNT}audio/
		# 	rm -rf "$mix_dir"
		# 	sync

		# 	freeAudio
		# 	aplay ${PS_ROOT}audio/completed.wav
		# 	freeAudioEnd
		# else
		# 	echo "Error during wav conversion : still OGG files !"
		# 	freeAudio
		# fi

		# # launch only one OGGDEC conversion at boot
		# break	
	done

	if [[ $one_sound_pack_processed -eq 1 ]]
	then
		echo "end processing zip sound pack"
		freeAudio
		aplay ${PS_ROOT}audio/completed.wav
		freeAudioEnd
	fi

	return 0;
}

function freeAudio()
{
	sendCommandPsoc "SOUNDOFF"

	killall mpg123 &> /dev/null
	killall aplay &> /dev/null
	
	sendCommandPsoc "SOUNDON"
	amixer set 'Line Out' $PS_ALSA_VOLUME_BASH
}

function freeAudioEnd()
{
	sendCommandPsoc "SOUNDOFF"
}

function findUnzipAudioMixZip()
{
	find ${PS_USB_MNT} -maxdepth 2 -type f -iname "*.zip" -a ! -iname "ERROR-*" | grep -v "${PS_USB_MNT}exclude/" | grep -v "${PS_USB_MNT}tmp/" | while read zip_file; do
		
		removeMixTreeCache

		#check space available on USB flash drive
		usb_free_space=$(getFreeSpace ${PS_USB_MNT})
		zip_size=$(stat -c%s "$zip_file")
		echo "$zip_file ~ size : $zip_size / $usb_free_space"
		unzip_space=$(echo "$zip_size * 2")
		if [[ $usb_free_space -gt $unzip_space ]]
		then

			random_music=$[($RANDOM % ($[3 - 1] + 1)) + 1]
			freeAudio
			mpg123 -q --loop 99 ${PS_ROOT}audio/music_conversion_${random_music}.mp3 &

			zip_tmp_path="${PS_USB_MNT}tmp/$(basename "$zip_file")"

			if [ -f "${zip_tmp_path}" ]
			then
			  rm "${zip_tmp_path}"
			  sync
			fi
			mv "${zip_file}" "${PS_USB_MNT}tmp/"
			sync
			
			#### DISABLED !!! ####		
			if [ 1 -eq 0 ]; then

				# first, we test the zip archive
				unzip -q -t "$zip_tmp_path"
				result_unzip=$?
				if [[ $result_unzip != 0 ]] 
				then
					# we move zip file to corrupted
					mv "$zip_tmp_path" "${PS_USB_MNT}ERROR-$(basename "$zip_file")"
					sync

					echo "zip may be corrupted"
					for run in {1..3}
					do
						freeAudio
						aplay ${PS_ROOT}audio/Zip_file_may_be_corrupted.wav
						freeAudioEnd
					done

					# user must fix the problem, we exit
					return 1;
				fi

			fi
			#### END DISABLED !!! ####

			# we unzip to tmp dir
			echo "> Unzip $zip_tmp_path"
			unzip -q -o -d ${PS_USB_MNT}tmp "${zip_tmp_path}"
			result_unzip=$?
			if [[ $result_unzip != 0 ]] 
			then
				sync
				echo "error during zip extraction"
				for run in {1..3}
				do
					freeAudio
					aplay ${PS_ROOT}audio/Error_during_zip_extraction.wav
					freeAudioEnd
				done

				return 1;
			else
				# remove zip file, useless now
				rm "$zip_tmp_path"
				sync
				freeAudio
			fi

			#check if unzipped mix is without directory container
			without_container=$(checkMoveMixWithoutContainer ${PS_USB_MNT}tmp ${PS_USB_MNT}tmp)

		else
			echo "The USB flash drive does not have enough free space."
			for run in {1..3}
			do
				freeAudio
				aplay ${PS_ROOT}audio/The_USB_flash_drive_does_not_have_enough_free_space.wav
				freeAudioEnd
			done
			return 1;
		fi

	done;

	return 0;
}

function findMovePSPack()
{
	if [[ $# -eq 0 ]]; then
		search_root=${PS_USB_MNT}
	else
		search_root="${1}"
	fi

	current_pspack=""

	# try to find if there are pspack in a child folder (except exclude) to move it back to the root
	# everything is scanned, except mix in "exclude" directory
	echo ${PS_USB_MNT}exclude
	find "$search_root" -maxdepth 2 -type f -a \( ! -path "${PS_USB_MNT}exclude/*" \) -a \( ! -path "${PS_USB_MNT}tmp/*" \)  -name "*.pspack" | sort | while read pspack; do
    	if [ "$current_pspack" != "$pspack" ]; then
    		echo "*** $pspack"
			mv "$pspack" ${PS_USB_MNT}
    	fi
    	current_pspack="$mix_directory"
	done
}


function findMoveAudioMix()
{
	if [[ $# -eq 0 ]]; then
		search_root=${PS_USB_MNT}
	else
		search_root="${1}"
	fi

	current_mix_directory=""

	# try to find if there are audio mixes elsewhere from /audio
	# everything is scanned, except mix in "exclude" directory
	echo ${PS_USB_MNT}exclude
	find "$search_root" -maxdepth 2 -type d \( ! -path '*/.*' \) -a \( ! -path "${PS_USB_MNT}exclude/*" \) -a \( ! -path "${PS_USB_MNT}tmp/*" \) -a \( -name "music" -o -name "sfx" -o -name "voice" \) | sed 's,/*[^/]\+/*$,,' | sort | while read mix_directory; do
    	if [ "$current_mix_directory" != "$mix_directory" ]; then
    		echo "*** $mix_directory"
			is_wav=$(isMixWavFormat "$mix_directory")
			if [[ $is_wav -eq 1 ]]
			then			
				moveAudioMix "$mix_directory" "audio"			
			else
				moveAudioMix "$mix_directory" "tmp"
			fi
    	fi
    	current_mix_directory="$mix_directory"
	done
}

function moveAudioMix()
{
	if [ ! -d ${PS_USB_MNT}$2 ]
	then
		mkdir ${PS_USB_MNT}$2
	fi

	directory=$(basename $1)

	if [ "$1" == "${PS_USB_MNT}audio" ] || [ "$1/" == "${PS_USB_MNT}" ]
	then
		# specific case : mix without container music,sfx,voice ...
		checkMoveMixWithoutContainer $1 ${PS_USB_MNT} 
		move_result=$?
		if [[ $move_result -eq 1 ]] 
		then
			return;
		fi
	fi

	# check if we try to move directory already at the right place
	if [ "${PS_USB_MNT}$2/$directory" != "$1" ]
	then
		echo "Move $1 mix into $2 : "
		mv "$1" "${PS_USB_MNT}$2"
		sync
		return;
	fi

	echo "Nothing to do"
	return;
}

function checkMoveMixWithoutContainer()
{
	count_types=`find "$1" \( ! -path '*/.*' \) -maxdepth 1 -type d \( -name "music" -o -name "sfx" -o -name "voice" -o -name "single" -o -name "jingle" \) 2>/dev/null | wc -l`
	if [[ $count_types -gt 0 ]]
	then
		# create new mix directory
		is_ogg=$(hasOggFiles "$1")
		if [[ $is_ogg -eq 1 ]]
		then			
			new_mix_dir=$(mktemp -d --tmpdir="$2/tmp" pinsound_mix_XXXX)
		else
			new_mix_dir=$(mktemp -d --tmpdir="$2/audio" pinsound_mix_XXXX)		
		fi
		
		find "${1}" \( ! -path '*/.*' \) -maxdepth 1 -type d \( -name "music" -o -name "sfx" -o -name "voice" -o -name "single" -o -name "jingle" \) | while read type_dir; do
			echo "$type_dir to mix : $new_mix_dir"
			mv "$type_dir" "$new_mix_dir"
			sync
		done
		return 1
	fi
	return 0
}

function isMixWavFormat()
{
	count_wav=`find "$1" -type f -iname "*wav" 2>/dev/null | wc -l`
	if [[ $count_wav -eq 0 ]]
	then
		echo 0
	else
		echo 1
	fi
}

function hasOggFiles()
{
	count_ogg=`find "$1" -type f -iname "*ogg" 2>/dev/null | wc -l`
	if [[ $count_ogg -gt 0 ]]
	then
		echo 1
	else
		echo 0
	fi
}

function getFreeSpace()
{
	free_space=$(df -P -B1 $1 | tail -1 | awk '{print $4}')
	echo $free_space
}

# rename PinSound directories to lower case 
function renamePinSoundDirectories()
{
#	find ${PS_USB_MNT} -maxdepth 1 -type d \( -iname "audio" -o -iname "playback" -o -iname "exclude" -o -iname "tmp" \)  -exec rename 's/(.*)\/([^\/]*)/$1\/\L$2/' {} \;
	return 0;
}

function removeMixTreeCache()
{
	if [ -f ${PS_USB_MNT}.cache ]
	then
			rm ${PS_USB_MNT}.cache
			echo "Mix tree cache removed"
	fi
}

function cleanUselessDirectories()
{

	#delete tmp folder if empty
	if [ -z "$(ls -A ${PS_USB_MNT}tmp)" ]; then
	   rmdir ${PS_USB_MNT}tmp
	fi

	#delete audio folder if empty
	if [ -z "$(ls -A ${PS_USB_MNT}audio)" ]; then
	   rmdir ${PS_USB_MNT}audio
	fi	
}



#########################################################
#               MAIN PROCESS
#########################################################

amixer set 'DAC' $PS_ALSA_VOLUME_DAC

# set ALSA volume not too high!
amixer set 'Line Out' $PS_ALSA_VOLUME_BASH

# mute SOUND
freeAudioEnd

sendCommandPsoc "LEDOFF"

#enable Knight Rider
sendCommandPsoc "BK2KON"

# mount pinsound usb
if  [ ! -e ${PS_USB_MNT} ]  
then
	mkdir ${PS_USB_MNT}
fi

if  [ ! -b ${PS_DEV_USB} ]  
then
        sendCommandPsoc "LEDOFF"
        ${PS_ROOT}bin/usb_reset
        umount -l ${PS_USB_MNT}
        sleep 7
        sendCommandPsoc "BK2KON"
        killall playPinSound
fi

for dev in /dev/sd*1; do
    if [ -b ${dev} ]; then
        PS_DEV_USB=${dev}  
    fi
done

if  [ -b ${PS_DEV_USB} ]  
then


	mountpoint -q ${PS_USB_MNT} || mount -o rw,errors=continue,flush ${PS_DEV_USB} ${PS_USB_MNT}

	if  [ -e /reboot1 ]
	then
    	mount -o remount,rw /
		rm /reboot1
	    sync
	    mount -o remount,ro /
    fi

	# if factory mode, quit to release console / serials for the test bench
	if [ -f ${PS_USB_MNT}factory.enabled ]
	then
			umount ${PS_USB_MNT}
			echo "PinSound factory mode enabled, exiting now"
	        exit 0;
	fi

	# check debug mode
	if [ -f ${PS_USB_MNT}config.ini ] && [ -f ${PS_ROOT}bin/readini ]
	then
		debug_boot=$(${PS_ROOT}bin/readini ${PS_USB_MNT}config.ini main debug_boot)
		if [[ $debug_boot -eq 1 ]]
		then
			exec 1> ${PS_USB_MNT}pinsound-boot-debug.log 2>&1
			echo "PinSound boot log enabled"
		else
			if [ -f ${PS_USB_MNT}pinsound-boot-debug.log ]
			then
				rm ${PS_USB_MNT}pinsound-boot-debug.log
			fi
		fi
	fi

	checkUpdate
	funcResult=$?
	if [[ $funcResult -ne 0 ]] 
	then
		exit 1
	fi

	checkInstallPrerequisites
	#funcResult=$?
	#if [[ $funcResult -eq 0 ]] 
	#then
		# if we got here, binaries are missing, we load default binaries
		#loadDefault

		# we recheck again
	#	checkInstallPrerequisites
	#	funcResult2=$?
	#	if [[ $funcResult2 -eq 0 ]] 
	#	then
	#		freeAudio
	#		aplay ${PS_AUDIO}Technical_problem_please_contact_the_support_team.wav
	#		freeAudioEnd
	#		exit 1
	#	fi
	#fi

	mount -o remount,ro /

	# manage audio mixes
	#renamePinSoundDirectories;
	#findMoveAudioMix; // disabled, in order to keep custom pspack at root
	#findMovePSPack; // disabled, in order to keep pspack within their expanded folder
	findUnzipAudioMixZip;
	processTmp;
	cleanUselessDirectories;

	# launch pinsound software
	for run in {1..3}
	do
		freeAudioEnd
		echo "Launch PinSound Software..."
		sendCommandPsoc "BK2KOFF"

		echo "amixer set 'Line Out' $PS_ALSA_VOLUME_PLAYPINSOUND"
        amixer set 'Line Out' $PS_ALSA_VOLUME_PLAYPINSOUND

  		${PS_PLAYPINSOUND} ${PS_USB_MNT}
	done
	funcResult=$?

	amixer set 'Line Out' $PS_ALSA_VOLUME_BASH

	# try to find what is the problem

	# exit 6 
	if [[ $funcResult -eq 6 ]] 
	then
		echo "Error: update required"
		for run in {1..3}
		do
			freeAudio
			aplay ${PS_AUDIO}Please_update_your_pinsound_firwmare.wav
			freeAudioEnd
		done
		exit 1
	fi

	# exit 10 = no sound package available on the USB flash drive
	if [[ $funcResult -eq 10 ]] 
	then
		echo "Error : no sound files on the USB flash drive or no sound package"
		sendCommandPsoc "LEDOFF"
		sendCommandPsoc "BLINKBLUE"
		for run in {1..3}
		do
			freeAudio
			aplay ${PS_AUDIO}There_are_no_sound_files_on_the_USB_flash_drive.wav
			freeAudioEnd
		done
		exit 1
	fi


	#if [ ! -d ${PS_USB_MNT}audio ]
	#then
	#	echo "Error : no audio directory"
	#	mkdir ${PS_USB_MNT}audio
	#	touch ${PS_USB_MNT}audio/put_your_audio_mixes_here.txt
	#	for run in {1..3}
	#	do
	#		freeAudio
	#		aplay ${PS_AUDIO}There_are_no_sound_files_on_the_USB_flash_drive.wav
	#		freeAudioEnd
	#	done
	#	exit 1
	#fi

	#if ! test "$(ls -A "${PS_USB_MNT}audio/")"
	#then
	#	echo "Error : no sound files on the USB flash drive"
	#	for run in {1..3}
	#	do
	#		freeAudio
	#		aplay ${PS_AUDIO}There_are_no_sound_files_on_the_USB_flash_drive.wav
	#		freeAudioEnd
	#	done
	#	touch ${PS_USB_MNT}audio/put_your_audio_mixes_here.txt
	#	exit 1
	#fi

	#count_wav=`find ${PS_USB_MNT}audio -type f -iname "*wav" 2>/dev/null | wc -l`
	#if [[ $count_wav -eq 0 ]]
	#then
	#	echo "Error : no wav files in the audio directory"
	#	for run in {1..3}
	#	do
	#		freeAudio
	#		aplay ${PS_AUDIO}There_are_no_wave_files_in_the_audio_directory.wav
	#		freeAudioEnd
	#	done
	#	exit 1
	#fi

	# last chance, we check the USB flash drive
	checkDiskUsb
	result_checkdisk=$?
	if [[ $result_checkdisk != 0 ]]
	then
		echo "Errors found on the USB flash drive"
		for run in {1..3}
		do
			freeAudio
			aplay ${PS_AUDIO}Please__restart_the_pinball_machine_now.wav
			freeAudioEnd
		done
		exit 0
	fi


	# if we get here, there is a major problem
	echo "Fatal tech issue"
	freeAudio
	aplay ${PS_AUDIO}Technical_problem_please_contact_the_support_team.wav
	freeAudioEnd
	exit 1

else

	if  [ ! -e /reboot1 ]
	then
		mount -o remount,rw /
        touch /reboot1

        ${PS_ROOT}bin/usb_reset

        sync
        mount -o remount,ro /

        reboot
        exit 0

    else

    	mount -o remount,rw /
		rm /reboot1
	    sync
	    mount -o remount,ro /

		sendCommandPsoc "READY"
		sendCommandPsoc "LEDBLUE"

	    freeAudio
		aplay ${PS_AUDIO}The_USB_flash_drive_is_not_present.wav
		freeAudioEnd
		exit 1
    fi
fi

freeAudioEnd


